;-----------------------------------------------------------------------------;
; MBRX - Boot Record Backup Tool
;-----------------------------------------------------------------------------;
; OPTASM 1.6 or later is required to build this program.
;-----------------------------------------------------------------------------;
;
; MBRX  Copyright (C)2002  ChaN
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;-----------------------------------------------------------------------------;


include	stddef.inc
include	str.inc
include	file.inc
include ibmpc.inc


PartitionTbl	struc
 BootID		db	?	; 80h:Active, 00:Inactive
 StartHead	db	?	; Jnwbhԍ
 StartSectCyl	dw	?	; JnZN^ԍƃV_ԍ
 SystemID	db	?	; OSʃR[h
 EndHead	db	?	; ŏIwbhԍ
 EndSectCyl	dw	?	; ŏIZN^ԍ
 PartitionOfs	dd	?	; JnZN^iLBAj
 PartitionSize	dd	?	; TCYiZN^j
PartitionTbl	ends



.model t
.data


StrOpen		db	'MBRX - Boot record backup/resotre tool. (C)ChaN, 2002.%n%n',0
StrUsage	db	'Usage: MBRX <command> <drive> <partition> [<filename>]%n%n'
		db	'<command>:   dump = Dump boot record%n'
		db	'             backup = Backup boot record (MBR/PBR)%n'
		db	'             restore = Restore boot record (MBR/PBR)%n'
		db	'             restore_code = Restore only boot code (MBR)%n'
		db	'             restore_table = Restore only partition table (MBR)%n'
		db	'             restore_ntsign = Restore only NT signature (MBR)%n'
		db	'<drive>:     0=1st, 1=2nd, ...%n'
		db	'<partition>: 0=MBR, 1=PBR1, ..., 4:PBR4%n'
		db	'<filename>:  File name to be backed-up/restored.%n',0
CrLf		db	CR,LF,'$'
StrFile		db	'Invalid boot record file.',0
MessSave	db	'Backing-up boot record...',0
MessRestore	db	'Restoreing boot record...',0
MessRestoreT	db	'Restoreing partiton table...',0
MessRestoreC	db	'Restoreing boot code...',0
MessRestoreN	db	'Restoreing NT signature...',0
EndProc		db	'Ok.%n',0
MessNoLba	db	'Disk error or No LBA support.%n',0
ErrRW		db	'Disk error.%n',0
ErrNoPartition	db	'No partition.%n',0

PbrInfo1	db	'Drive:$'
PbrInfo2	db	', Partition:$'
PbrInfo3	db	', Offset:$'
PbrInfo4	db	', Size:$'
PbrInfo5	db	', Type:0x$'
MbrInfo3	db	', Master Boot Record',CR,LF,CR,LF,'$'
MbrInfo2	db	' 0x$'
MbrInfo1	db	CR,LF,'#  CHS Start    CHS End   LBA Offset  LBA Size  Boot System ID',CR,LF
		db	      '- ----------- ----------- ---------- ---------- ---- -----------------------',CR,LF,'$'

OsTable		db	01h,'DOS FAT12',0
		db	04h,'DOS FAT16(<32M)',0
		db	05h,'DOS Extend',0
		db	06h,'DOS FAT16(32M-2G)',0
		db	07h,'HPFS/NTFS',0
		db	0bh,'DOS FAT32',0
		db	0ch,'DOS FAT32X',0
		db	0eh,'DOS FAT16X',0
		db	0fh,'DOS ExtendX',0
		db	11h,'DOS FAT12',0
		db	13h,'B-right/V',0
		db	14h,'DOS FAT16(<32M)',0
		db	15h,'DOS Extend',0
		db	16h,'DOS FAT16(32M-2G)',0
		db	17h,'HPFS/NTFS',0
		db	1bh,'DOS FAT32',0
		db	1ch,'DOS FAT32X',0
		db	1eh,'DOS FAT16X',0
		db	1fh,'DOS ExtendX',0
		db	39h,'Plan 9',0
		db	71h,'EOTA',0
		db	81h,'Minix/Linux extfs',0
		db	82h,'Solaris/Linux swap',0
		db	83h,'Linux ext2fs',0
		db	85h,'Linux Extend',0
		db	0a0h,'Suspend',0
		db	0a4h,'FreeBSD',0
		db	0a5h,'FreeBSD',0
		db	0a6h,'OpenBSD',0
		db	0a9h,'NetBSD',0
		db	0c1h,'DRDOS',0
		db	0c4h,'DRDOS',0
		db	0c6h,'DRDOS(32M-2G)',0
		db	0ebh,'BeOS',0
		db	0,   'Unknown',0

CmdStrD		db	'dump',0
CmdStrB		db	'backup',0
CmdStrR		db	'restore',0
CmdStrRC	db	'restore_code',0
CmdStrRT	db	'restore_table',0
CmdStrRN	db	'restore_ntsign',0

Drive		db	?
Partition	db	?

MbrBuffer	db	512 dup(?)	; u[gR[hǂݏobt@
		org	$-64-2		; e[uiMBR̂݁j
 MbrPartition	PartitionTbl	<>
		PartitionTbl	<>
		PartitionTbl	<>
		PartitionTbl	<>
 MbrSign	dw	?		; VOl`iAA55hj

PbrBuffer	db	512 dup(?)	; PBR buffer


Hand		dw	?
MbrFileName	db	40 dup(?)

Argc		db	?
Argv		dw	5 dup(?)

Pool		db	?



;-------------------------------------------------;
; Main

.186
.code

		DEF_PSP
start:
		FPRIN	StrOpen
		GET_CMD_PAR  Argc, Argv
	_skip b, Argc,3
		mov	bx,Argv[2]
		mov	al,[bx]
		sub	al,'0'
		add	al,80h
		mov	Drive,al
		mov	bx,Argv[4]
		mov	al,[bx]
		sub	al,'0'
		mov	Partition,al
	 _skip a, al, 4
		CMP_STR Argv[0],<ofs CmdStrD>,<len CmdStrD>
		je	dump
	  _skip b, Argc,4
		CMP_STR Argv[0],<ofs CmdStrB>,<len CmdStrB>
		je	backup
		CMP_STR Argv[0],<ofs CmdStrRC>,<len CmdStrRC>
		je	restore_code
		CMP_STR Argv[0],<ofs CmdStrRN>,<len CmdStrRN>
		je	restore_ntsign
		CMP_STR Argv[0],<ofs CmdStrRT>,<len CmdStrRT>
		je	restore_table
		CMP_STR Argv[0],<ofs CmdStrR>,<len CmdStrR>
		je	restore
	___endif

usage:
		FPRIN	StrUsage
		$DOS  4ch,1

file_err:	FPRIN	StrFile
		$DOS  4ch,1

dos_err:	ERR_OUT
		$DOS  4ch,1


;-------------------------------------------------;
; Dump

dump:
		 call	chk_lba
		 call	read_mbr

	_if e, Partition, 0
		PRINT	PbrInfo1
		mov	al, Drive
		and	al, 7fh
		 call	put_num1a
		PRINT	MbrInfo3
		mov	si, ofs MbrBuffer
		 call	dump_sector
	 _skip ne, MbrSign, 0aa55h
		PRINT MbrInfo1
		clr	ax, bx
	  _repeat 4
		inc	al
		push	ax, cx
		 call	mbr_info
		pop	cx, ax
		add	bx, type PartitionTbl
	  _loop
	 _endif
	_else
		 call	get_pbraddr
		push	bx
		 call	read_pbr
		pop	bx
		PRINT PbrInfo1
		mov	al, Drive
		and	al, 7fh
		 call	put_num1a
		PRINT PbrInfo2
		mov	al, Partition
		 call	put_num1a
		PRINT PbrInfo3
		db 66h
		mov	ax, wptr MbrPartition[bx].PartitionOfs
		 call	put_num4a
		PRINT PbrInfo4
		db 66h
		mov	ax, wptr MbrPartition[bx].PartitionSize
		 call	put_num4a
		PRINT PbrInfo5
		mov	al, MbrPartition[bx].SystemID
		 call	put_hex
		 call	space
		mov	ah, MbrPartition[bx].SystemID
		 call	get_osname
		 call	put_str
		PRINT CrLf
		PRINT CrLf
		mov	si, ofs PbrBuffer
		 call	dump_sector
	_endif

		$DOS  4ch, 0


mbr_info:
		 call	put_num1a
	_skip e, MbrPartition[bx].SystemID, 0
		mov	ax, MbrPartition[bx].StartSectCyl
		xchg	al, ah
		shr	ah, 6
		mov	dl, 5
		 call	put_num2
		mov	al, '/'
		 call	put_chr
		mov	al, MbrPartition[bx].StartHead
		mov	dl, 3
		 call	put_num1
		mov	al, '/'
		 call	put_chr
		mov	ax, MbrPartition[bx].StartSectCyl
		and	al, 63
		mov	dl, 2
		 call	put_num1

		mov	ax, MbrPartition[bx].EndSectCyl
		xchg	al, ah
		shr	ah, 6
		mov	dl, 5
		 call	put_num2
		mov	al, '/'
		 call	put_chr
		mov	al, MbrPartition[bx].EndHead
		mov	dl, 3
		 call	put_num1
		mov	al, '/'
		 call	put_chr
		mov	ax, MbrPartition[bx].EndSectCyl
		and	al, 63
		mov	dl, 2
		 call	put_num1

		db 66h
		mov	ax, wptr MbrPartition[bx].PartitionOfs
		mov	dl, 11
		 call	put_num4
		db 66h
		mov	ax, wptr MbrPartition[bx].PartitionSize
		mov	dl, 11
		 call	put_num4

		PRINT	MbrInfo2
		mov	al, MbrPartition[bx].BootID
		 call	put_hex

		PRINT	MbrInfo2
		mov	al, MbrPartition[bx].SystemID
		 call	put_hex
		mov	al, ','
		 call	put_chr

		mov	al, MbrPartition[bx].SystemID
		 call	get_osname
		 call	put_str
	_endif
		PRINT	CrLf
		ret



;-------------------------------------------------;
; Backup

backup:
		 call	chk_lba
		FPRIN  MessSave
		 call	read_mbr
	_skip e, Partition, 0
		 call	get_pbraddr
		 call	read_pbr
		MOV_MEM <ofs PbrBuffer>,<ofs MbrBuffer>,512
	_endif
		MAKE_FILE  0,Argv[6]
		jc	dos_err
		mov	Hand,ax
		WRITE_FILE  Hand,<ofs MbrBuffer>,512
		jc	dos_err
		CLOSE_FILE

		FPRIN EndProc
		$DOS  4ch,0


;-------------------------------------------------;
; Restore table

restore_table:
		cjne	Partition, 0, usage

		 call	chk_lba
		 call	read_file
		MOV_MEM <ofs MbrBuffer>,<ofs PbrBuffer>,512

		FPRIN  MessRestoreT

		 call	read_mbr
		MOV_MEM <ofs PbrBuffer[1beh]>,<ofs MbrBuffer[1beh]>,40h
		 call	write_pbr

		FPRIN EndProc
		$DOS  4ch,0


;-------------------------------------------------;
; Restore code

restore_code:
		cjne	Partition, 0, usage

		 call	chk_lba
		 call	read_file
		MOV_MEM <ofs MbrBuffer>,<ofs PbrBuffer>,512

		FPRIN  MessRestoreC

		 call	read_mbr
		MOV_MEM <ofs PbrBuffer[0]>,<ofs MbrBuffer[0]>,1b0h
		 call	write_pbr

		FPRIN EndProc
		$DOS  4ch,0


;-------------------------------------------------;
; Restore NT signature

restore_ntsign:
		cjne	Partition, 0, usage

		 call	chk_lba
		 call	read_file
		MOV_MEM <ofs MbrBuffer>,<ofs PbrBuffer>,512

		FPRIN  MessRestoreN

		 call	read_mbr
		MOV_MEM <ofs PbrBuffer[1b0h]>,<ofs MbrBuffer[1b0h]>,0eh
		 call	write_pbr

		FPRIN EndProc
		$DOS  4ch,0


;-------------------------------------------------;
; Restore

restore:
		 call	chk_lba
		 call	read_file

		FPRIN  MessRestore

	_if e, Partition, 0
		 call	write_mbr
	_else
		MOV_MEM <ofs MbrBuffer>,<ofs PbrBuffer>,512
		 call	read_mbr
		 call	get_pbraddr
		 call	write_pbr
	_endif

		FPRIN EndProc
		$DOS  4ch,0


;-------------------------------------------------;

		PRINTF_F

get_pbraddr:
	_skip ne, MbrSign, 0aa55h
		clr	ax
		mov	al, Partition
		dec	al
		imul	bx, ax, type PartitionTbl
	 _skip e, MbrPartition[bx].SystemID, 0
		db 66h
		mov	ax, wptr MbrPartition[bx].PartitionOfs
		ret
	__endif
		FPRIN ErrNoPartition
		$DOS  4ch,0


dump_sector:
		clr	bx
	_repeat 32
		push	cx
		mov	al, bh
		 call	put_hex
		mov	al, bl
		 call	put_hex
		 call	space
	 _repeat 16
		 call	space
		test	bl, 111b
	  @if z,<call	space>
		mov	al, [si][bx]
		 call	put_hex
		inc	bx
	 _loop
		sub	bx, 16
		 call	space
		 call	space
		 call	space
	 _repeat 16
		mov	al, [si][bx]
	  _if ae, al, 7fh
		mov	al, '.'
	  _endif
	  _if b, al, 20h
		mov	al, '.'
	  _endif
		 call	put_chr
		inc	bx
	 _loop
		PRINT	CrLf
		pop	cx
	_loop
		ret


put_hex:	mov	ah, al
		shr	al, 4
		 call	put_h2
		mov	al, ah
		and	al, 0fh
	put_h2:	add	al, '0'
	_if a, al, '9'
		add	al, 7
	_endif
		jmp	put_chr


space:		mov	al, ' '
put_chr:	pusha
		mov	dl, al
		$DOS 2
		popa
		ret



read_file:
		OPEN_FILE  0,Argv[6]
		jc	dos_err
		mov	Hand,ax
		READ_FILE  Hand,<ofs MbrBuffer>,512
		jc	dos_err
		cjne	ax,512, file_err
		CLOSE_FILE
		cjne	<wptr MbrBuffer[510]>, 0aa55h, file_err
		ret


read_pbr:
		mov	bx,ofs PbrBuffer
		jmp	read_sect
read_mbr:
		db 66h
		clr	ax
		mov	bx,ofs MbrBuffer
read_sect:	push	0,0
		db 66h	;push eax
		push	ax, ds,bx, 1, 16
		mov	si, sp
		mov	dl, Drive
		$DISK  42h,0
		lea	sp, [si].16
	_if c
		FPRIN ErrRW
		$DOS  4ch,1
	_endif
		ret


write_pbr:
		mov	bx,ofs PbrBuffer
		jmp	write_sect
write_mbr:
		db 66h
		clr	ax
		mov	bx,ofs MbrBuffer
write_sect:	push	0,0
		db 66h	;push eax
		push	ax, ds,bx, 1, 16
		mov	si, sp
		mov	dl, Drive
		$DISK  43h,0
		lea	sp, [si].16
	_if c
		FPRIN ErrRW
		$DOS  4ch,1
	_endif
		ret


chk_lba:
		mov	bx, 55aah
		mov	dl, Drive
	_skip c,<$DISK  41h>
	 _skip ne, bx, 0aa55h
	  _skip z, <test cl, BIT0>
		mov	si, ofs Pool
		mov	wptr[si], 1ah
	   _skip c, <$DISK  48h>
		ret
	____endif
		FPRIN  MessNoLba
		$DOS  4ch, 1


get_osname:				; Call:
		mov	si, ofs OsTable	;  ah = OS code
	_while				; Ret:
		lodsb			;  si -> String
		ret e, ah, al
	 _while
		lodsb
	 _rept ne, al,0
	_rept ne, bptr[si], 0
		inc	si
		ret


div_eax:				; Call: eax = dividend
		test	cl, cl		;       cl = divisor (0 is 256)
		jz	de_256		; Ret:  eax = result
		clr	bl		;       bl = remander
		mov	ch, 32
	 _while
		db 66h		;shl
		shl	ax,1	;eax,1
		rcl	bl, 1
		jc	de_s
		cmp	bl, cl
		jb	de_n
	  de_s:	inc	ax
		sub	bl, cl
	  de_n:	dec	ch
	 _rept nz
		ret
	de_256:	mov	bl, al
		db 66h		;shr
		shr	ax, 8	;eax,8
		ret


put_str:
	_while
		lodsb
	 _break e, al, 0
		 call	put_chr
	_rept
		ret

put_num4a:	clr	dl
		jmp	put_num4
put_num2a:	clr	dl
		jmp	put_num2
put_num1a:	clr	dl
put_num1:	clr	ah
put_num2:	db 66h
		and ax,-1
		dw 0
put_num4:	push	bx
		clr	bh
	_while
		mov	cl, 10
		 call	div_eax
		inc	bh
		add	bl, '0'
		push	bx
		db 66h		;and
		and	ax, ax	;eax,eax
	_rept nz
	_while b, bh,dl
		inc	bh
		push	' '
	_rept
		shr	bx, 8
	_repeat bx
		pop	ax
		 call	put_chr
	_loop
		pop	bx
		ret



		$end	start
